<template>
    <tr :style="style">
        <td>{{project.id}}</td>
        <!-- <td>
            <div v-if = "edit == false">
                <label> {{role}} </label>
            </div>
            <select v-else name="role" v-model = "role" v-on:input="role = $event.target.value" class="input-edit">
                <option value="developer">developer</option>
                <option value="visitor">visitor</option>
            </select>
        </td> -->
        <td>
            <div v-if = "edit == false">
                <label>{{project.name}}</label>
            </div>
            <input v-else name="name" v-model = "project.name" v-on:input="project.name = $event.target.value" class="input-edit">
        </td>
        <td>
            <div v-if = "edit == false">
                <label> {{project.capacity}} </label>
            </div>
            <input v-else name="capacity" type="number" v-model = "project.capacity" v-on:input="project.capacity = $event.target.value" class="input-edit">
        </td>
        <td>
            <div v-if = "edit == false">
                <label> {{project.lang}} </label>
            </div>
            <select v-else name="lang" v-model = "project.lang" v-on:input="project.lang = $event.target.value" class="input-edit">
                <option value="js">js</option>
                <option value="php">php</option>
            </select>
        </td>
        <td v-if="createdBy !== 0">
            <div>
                <label> {{createdBy}} </label>
            </div>
        </td>
        <td class="actions">
            <button v-if = "edit == false" @click="updateEditValue" class="edit-button">Edit</button>
            <button v-else @click="onClickUpdateProject" class="edit-button">Save</button>
            <button @click="onClickDeleteProject" class="delete-button">Delete</button>
            <button @click="onClickShowProjects" class="show-button">See details</button>
        </td>
    </tr>
</template>

<script>
export default {
    props: ['index', 'project', 'userId', 'edit', 'role', 'createdBy'],
    name: 'ProjectListAdmin',
    data() {
        return {
            style: {
                backgroundColor: '',
            },
        }
    },
    computed: {
    },
    methods: {
        onClickDeleteProject() {
            this.$axios.delete(process.env.VUE_APP_API_URL+'/projects/'  + this.project.id, 
            { data:{ project: this.project}}).then(() => {
                this.$el.parentNode.removeChild(this.$el)
            })
        },
        onClickUpdateProject() {
            const data = {
                name: this.project.name,
                lang: this.project.lang,
                capacity: this.project.capacity,
            }
            this.updateEditValue()
            fetch(process.env.VUE_APP_API_URL+'/projects/' + this.project.id, {
                headers: {
                    'Content-Type': 'application/json'
                },
                method: 'PUT',
                body: JSON.stringify(data)
            })
        },
        onClickShowProjects() {
            this.$router.push('/dashboard-admin/project/' + this.project.slug);
        },
        updateEditValue: function(){
            if(this.edit == true) {
                this.edit = false
            } else this.edit = true
        },
    },
    mounted() {
    }
}
</script>

<style scoped>
.container-dashboard-admin {
    display: flex;
    flex-direction: row;
    align-items: center;
    padding: 12px;
}

tr {
    color:black;
}

button {
    cursor: pointer;
    padding: 4px 8px !important;
    border-radius: 4px;
    border: 1px solid #ececec;
}

.edit-button {
    background-color: rgba(102, 255, 102, 0.3);
}

.delete-button {
    background-color: rgba(239, 42, 130, 0.3);
}

.show-button {
    background-color: rgba(30, 7, 155,0.3);
}

.actions {
    display: flex;
    align-items: center;
    justify-content: space-evenly;
}

td {
    background-color: rgba(30, 7, 155,0.1);
}

.input-edit {
    border: 3px solid rgba(189, 189, 189,0.2);
    background-color: white;
}
</style>
